/*
  ******************************************************************************
  * @file    spi.h
  * @author  Angel_YY
  * @version V1.0.0
  * @date    2021
  * @brief   spi demo Header file.
  ******************************************************************************
*/

#ifndef __SPI_H__
#define __SPI_H__

#include "stdint.h"

#define SPIz          SPI2
#define SPIz_CLK      RCC_APB1_PERIPH_SPI2
#define SPIz_GPIO     GPIOB
#define SPIz_GPIO_CLK RCC_APB2_PERIPH_GPIOB
#define SPIz_PIN_SCK  GPIO_PIN_13
#define SPIz_PIN_MISO GPIO_PIN_14
#define SPIz_PIN_MOSI GPIO_PIN_15

/* Uncomment the line corresponding to the desired System clock (SYSCLK)
   frequency (after reset the HSI is used as SYSCLK source) */
//#define SYSCLK_HSI
//#define SYSCLK_HSE
#define SYSCLK_PLLHSI_FREQ_24MHz
//#define SYSCLK_PLLHSI_FREQ_36MHz
//#define SYSCLK_PLLHSI_FREQ_48MHz
//#define SYSCLK_PLLHSI_FREQ_56MHz
//#define SYSCLK_PLLHSI_FREQ_72MHz
//#define SYSCLK_PLLHSI_FREQ_96MHz
//#define SYSCLK_PLLHSE_FREQ_24MHz
//#define SYSCLK_PLLHSE_FREQ_36MHz
//#define SYSCLK_PLLHSE_FREQ_48MHz
//#define SYSCLK_PLLHSE_FREQ_56MHz
//#define SYSCLK_PLLHSE_FREQ_72MHz
//#define SYSCLK_PLLHSE_FREQ_96MHz
//#define SYSCLK_PLLHSE_FREQ_144MHz

int spi_all_master_init(void);

int InitFRAM(void);
int Fram_ReadData(unsigned short addr,unsigned char *pData,int len);
int Fram_WriteData(unsigned short addr,unsigned char * pData,int len);

#endif